package tptel.modele;
// Generated 4 Oct 2021, 11:17:05 by Hibernate Tools 5.4.30.Final

import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


/**
 * Abonnement generated by hbm2java
 */

@Entity
@Table(name = "abonnement")
public class Abonnement implements java.io.Serializable {

	private Integer idAbonnement;
	private Client client;
	private String nomAbonnement;
	private Date dateAbonnement;
	private float solde;
	private Set<Facture> factures = new HashSet(0);

	public Abonnement() {
	}

	public Abonnement(Client client, String nomAbonnement, Date dateAbonnement, float solde) {
		this.client = client;
		this.nomAbonnement = nomAbonnement;
		this.dateAbonnement = dateAbonnement;
		this.solde = solde;
	}

	public Abonnement(Client client, String nomAbonnement, Date dateAbonnement, float solde, Set<Facture> factures) {
		this.client = client;
		this.nomAbonnement = nomAbonnement;
		this.dateAbonnement = dateAbonnement;
		this.solde = solde;
		this.factures = factures;
	}

	
	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "idAbonnement",unique=true, nullable = false)
	public Integer getIdAbonnement() {
		return this.idAbonnement;
	}

	public void setIdAbonnement(Integer idAbonnement) {
		this.idAbonnement = idAbonnement;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "prop", nullable = false)
	public Client getClient() {
		return this.client;
	}

	public void setClient(Client client) {
		this.client = client;
	}

	@Column(name = "nomAbonnement", nullable = false, length = 25)
	public String getNomAbonnement() {
		return this.nomAbonnement;
	}

	public void setNomAbonnement(String nomAbonnement) {
		this.nomAbonnement = nomAbonnement;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "dateAbonnement", nullable = false, length = 10)
	public Date getDateAbonnement() {
		return this.dateAbonnement;
	}

	public void setDateAbonnement(Date dateAbonnement) {
		this.dateAbonnement = dateAbonnement;
	}

	@Column(name = "solde", nullable = false, length = 25)
	public float getSolde() {
		return this.solde;
	}

	public void setSolde(float solde) {
		this.solde = solde;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "abonnement")
	public Set<Facture> getFactures() {
		return this.factures;
	}

	public void setFactures(Set<Facture> factures) {
		this.factures = factures;
	}

}
